<template>
    <modal
        name="store-package"
        height="auto"
        :shiftY="0.2"
        @before-open="beforeOpen"
        :clickToClose="false"
        :scrollable="true"
    >
        <div class="modal-header">
            <h5 class="modal-title">Product</h5>

            <div class="close" @click="$modal.hide('store-package')">
                <span aria-hidden="true">&times;</span>
            </div>
        </div>

        <div class="modal-body">
            <div class="form-group">
                <label>Name</label>
                <input
                    type="text"
                    v-model="package.name"
                    class="form-control"
                />
            </div>

            <div class="form-group mt-4">
                <label>Price</label>
                <input
                    type="number"
                    v-model="package.price"
                    class="form-control"
                />
            </div>
        </div>

        <div class="modal-footer">
            <button
                v-if="view == 'create'"
                type="button"
                class="btn btn-success"
                :disabled="!package.name || !package.price"
                @click="create()"
            >
                <i class="fas fa-save pr-2"></i> Create
            </button>

            <button
                v-if="view == 'edit'"
                type="button"
                class="btn btn-success"
                :disabled="!package.name || !package.price"
                @click="update()"
            >
                <i class="fas fa-save pr-2"></i> Update
            </button>

            <button
                v-if="view == 'edit'"
                type="button"
                class="btn btn-danger"
                @click="remove()"
            >
                <i class="fas fa-trash pr-2"></i> Delete
            </button>
        </div>
    </modal>
</template>

<script>
export default {
    props: ["packages"],

    data() {
        return {
            package: {
                name: null,

                price: null
            },

            view: "create"
        };
    },

    methods: {
        beforeOpen(event) {
            event.params.package
                ? (this.package = JSON.parse(
                      JSON.stringify(event.params.package)
                  ))
                : [];

            event.params.view ? (this.view = event.params.view) : [];
        },

        create() {
            axios.post("/api/packages/store", this.package).then(response => {
                // Close modal
                this.$modal.hide("store-package");

                // Add package in list
                this.packages.unshift(response.data);

                this.$emit("package-create", { package: response.data });

                // Show notification
                this.$toasted.show(
                    "<i class='fas fa-check mr-2'></i> Product Succesfully Created"
                );
            });
        },

        update() {
            axios
                .put("/api/packages/" + this.package.id, this.package)
                .then(response => {
                    const index = this.packages.findIndex(item => {
                        return response.data.id === item.id;
                    });

                    this.packages.splice(index, 1, response.data);

                    // Close modal
                    this.$modal.hide("store-package");

                    // Show notification
                    this.$toasted.show(
                        "<i class='fas fa-check mr-2'></i> Product Succesfully Updated"
                    );
                });
        },

        remove() {
            Vue.toasted.clear();

            this.$toasted.show(
                "<i class='fas fa-trash-alt mr-2'> </i> Delete Product ?",
                {
                    type: "error",

                    duration: null,

                    action: [
                        {
                            text: "Yes",

                            onClick: (e, toastObject) => {
                                toastObject.goAway(0);

                                axios
                                    .post(
                                        "/api/packages/delete/" +
                                            this.package.id
                                    )
                                    .then(response => {
                                        this.packages.splice(this.package, 1);

                                        // Close modal
                                        this.$modal.hide("store-package");

                                        this.$toasted.show(
                                            "<i class='fas fa-check mr-2'></i> Product Successfully Deleted !"
                                        );
                                    });
                            }
                        },
                        {
                            text: "Cancel",

                            onClick: (e, toastObject) => {
                                toastObject.goAway(0);
                            }
                        }
                    ]
                }
            );
        }
    }
};
</script>
